/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "./";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 7);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__barrel_js__ = __webpack_require__(1);
var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }



var RcaMoney = function () {
    function RcaMoney(conf) {
        _classCallCheck(this, RcaMoney);

        this.free_sale = conf.free_sale || false;
        this.bills = new __WEBPACK_IMPORTED_MODULE_0__barrel_js__["a" /* Bills */](conf);
        this.bankSlip = new __WEBPACK_IMPORTED_MODULE_0__barrel_js__["b" /* BankSlip */](conf.boleto);
    }

    _createClass(RcaMoney, [{
        key: 'formatedOnlyParcel',
        value: function formatedOnlyParcel(totalValue) {
            var hasDestiny = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            if (!totalValue) {
                return '';
            }

            var view = this._formatedOnlyParcel(totalValue);

            if (hasDestiny) {
                return this._getDestiny(hasDestiny).innerHTML = view.get();
            }
            return view.get();
        }
    }, {
        key: 'formatedPriceAndParcelLong',
        value: function formatedPriceAndParcelLong(totalValue, timeInMs) {
            var hasDestiny = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;


            var view = this._formatedOnlyParcel(totalValue);
            view.addContent('text', this._getShortTextPayment(totalValue, timeInMs));

            if (hasDestiny) {
                return this._getDestiny(hasDestiny).innerHTML = view.get();
            }
            return view.get();
        }
    }, {
        key: '_formatedOnlyParcel',
        value: function _formatedOnlyParcel(totalValue) {
            var installments = this.bills.getMaxParcel(totalValue);
            var total = this._getFormatedParcel(totalValue);

            var view = new __WEBPACK_IMPORTED_MODULE_0__barrel_js__["c" /* MoneyView */]('box-price');
            view.addContent('parcel', installments + 'x');
            view.addContent('', total);

            return view;
        }
    }, {
        key: '_getFormatedParcel',
        value: function _getFormatedParcel(value) {
            return this._mountPriceDecoration(this.bills.priceFormat(this.bills.getMaxParcelValueByTotal(value)));
        }
    }, {
        key: '_getShortTextPayment',
        value: function _getShortTextPayment(total, timeInMs) {
            var view = new __WEBPACK_IMPORTED_MODULE_0__barrel_js__["c" /* MoneyView */]('paymentTypes');
            view.addContent('spotlight', 'nos Cartões');

            if (this.free_sale || this.bankSlip.validateBoleto(timeInMs)) {
                var price = this.bills.priceFormat(this.bankSlip.getValueWithDiscount(total));
                view.addContent('text', 'ou');
                view.addContent('price', price);
                view.addContent('', 'no boleto');
            }

            return view.get();
        }
    }, {
        key: '_mountPriceDecoration',
        value: function _mountPriceDecoration(formatedPrice) {
            var money = formatedPrice.split(this.bills.priceFormatValues['decimalSymbol']);
            var cents = this.bills.priceFormatValues['decimalSymbol'] + this.bills.formatCents(money[1]);
            var view = new __WEBPACK_IMPORTED_MODULE_0__barrel_js__["c" /* MoneyView */]('price');
            view.addContent('real', money[0]);
            view.addContent('cents', cents);

            return view.get();
        }
    }, {
        key: '_getDestiny',
        value: function _getDestiny(destiny) {
            return document.querySelector(destiny);
        }
    }]);

    return RcaMoney;
}();

/* harmony default export */ __webpack_exports__["default"] = (RcaMoney);


window.RcaMoney = RcaMoney;

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__money_view_MoneyView__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__money_Bills__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__money_BankSlip__ = __webpack_require__(2);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return __WEBPACK_IMPORTED_MODULE_0__money_view_MoneyView__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return __WEBPACK_IMPORTED_MODULE_1__money_Bills__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return __WEBPACK_IMPORTED_MODULE_2__money_BankSlip__["a"]; });








/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BankSlip = function () {
    function BankSlip(confBoleto) {
        _classCallCheck(this, BankSlip);

        this.descBoleto = confBoleto.boletoDiscount || 0;
        this.qtyDayProcess = confBoleto.boletoDayProcess || 3;
        this.today = new Date();
    }

    _createClass(BankSlip, [{
        key: "getValueWithDiscount",
        value: function getValueWithDiscount(total) {
            return total * ((100 - this.descBoleto) / 100);
        }
    }, {
        key: "validateBoleto",
        value: function validateBoleto(timeInMs) {
            var diff = this._getDateDiff(timeInMs);
            if (this.qtyDayProcess < diff) {
                return true;
            } else {
                return false;
            }
        }
    }, {
        key: "_getDateDiff",
        value: function _getDateDiff(timeInMs) {
            var date2 = new Date(timeInMs);
            var timeDiff = Math.abs(date2.getTime() - this.today.getTime());
            var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));

            return diffDays;
        }
    }]);

    return BankSlip;
}();

/* harmony default export */ __webpack_exports__["a"] = (BankSlip);

/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Bills = function () {
    function Bills(conf) {
        _classCallCheck(this, Bills);

        this.ROUND_FACTOR = conf.round_factor || 0.004;
        this.interestFactor = conf.interestFactor || [];
        this.priceFormatValues = conf.priceFormat || {};
        this.maxParcels = conf.maxParcels || 10;
        this.minValueParcel = conf.minValueParcel || 5;
        this.descBoleto = conf.descBoleto || 0;
        this.addShortPhase = conf.addShortPhase || 1;
    }

    _createClass(Bills, [{
        key: 'calcParcels',
        value: function calcParcels(parcel, total) {
            var factor = this.interestFactor[1];
            if (this.interestFactor[parcel]) {
                factor = this.interestFactor[parcel];
            }

            var data = {};

            data['installment_value'] = this._calcInstallmentValue(total, factor);
            if (factor.interest) {
                data['total_value'] = data['installment_value'] * parcel;
                data['total_value_diference'] = this._round(data['total_value'] - total + this.ROUND_FACTOR);
                data['installment_value_diference'] = 0;
            } else {
                data['total_value'] = total;

                data['installment_value_diference'] = data['total_value'] - data['installment_value'] * parcel;

                data['total_value_diference'] = 0;
            }

            data['base_total_value'] = data['total_value'];
            data['base_installment_value'] = data['installment_value'] + data['installment_value_diference'];

            return data;
        }
    }, {
        key: '_calcInstallmentValue',
        value: function _calcInstallmentValue(total, factor) {
            var base = total * factor.factor;
            var calc = factor.interest ? base + this.ROUND_FACTOR : base - this.ROUND_FACTOR;
            return this._round(calc, this.priceFormatValues['precision']);
        }
    }, {
        key: '_round',
        value: function _round(value) {
            var hasDecimals = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            // if (hasDecimals) {
            //     console.log(Number(Math.round(value + 'e' + hasDecimals) + 'e-' + hasDecimals))
            //     return Number(Math.round(value + 'e' + hasDecimals) + 'e-' + hasDecimals);
            // }

            return Math.round(value * 100) / 100;
        }
    }, {
        key: 'priceFormat',
        value: function priceFormat(value) {
            //var totalPrice = ( parseFloat( Math.round( value * 100 ) / 100 ).toFixed(this.priceFormatValues['precision']) );
            var totalPrice = this._round(value, this.priceFormatValues['precision']);
            totalPrice = parseFloat(totalPrice);

            var priceParts = totalPrice.toString().split('.');
            var mainValue = this._addMilharPoint(priceParts[0]);
            var cents = this.formatCents(priceParts[1]);
            var totalPriceFormated = mainValue + this.priceFormatValues['decimalSymbol'] + cents;

            totalPriceFormated = this.priceFormatValues['pattern'].replace('%s', ' ' + totalPriceFormated);

            return totalPriceFormated;
        }
    }, {
        key: '_addMilharPoint',
        value: function _addMilharPoint(value) {
            var calc = '';
            var length = value.length;
            var ini = 0;

            if (length <= 3) {
                return value;
            }

            for (var x = length; x >= 0; x -= 3) {
                ini = x - 3 < 0 ? 0 : x - 3;
                if (x === length) {
                    calc = value.slice(ini, x);
                } else {
                    calc = value.slice(ini, x) + '.' + calc;
                }
            }

            var newValue = calc.replace(/^['.']/, '');
            return newValue;
        }
    }, {
        key: 'formatCents',
        value: function formatCents(cents) {
            if (!cents) {
                return "00";
            }

            cents = cents.toString();
            var newCents = (cents + '0').slice(-3, 2);

            return newCents;
        }
    }, {
        key: 'getMaxParcelValueByTotal',
        value: function getMaxParcelValueByTotal(total) {
            var values = this.calcParcels(this.getMaxParcel(total), total);
            return values.base_installment_value;
        }
    }, {
        key: 'getMaxParcel',
        value: function getMaxParcel(total) {
            if (!total || !this.minValueParcel || !this.maxParcels) {
                return 0;
            }

            var aux = 1;
            for (var i = 1; i <= this.maxParcels; i++) {
                var values = this.calcParcels(i, total);

                if (values.installment_value >= this.minValueParcel) {
                    aux = i;
                } else {
                    return aux;
                }
            }

            return aux;
        }
    }, {
        key: '_normalizeReturn',
        value: function _normalizeReturn(lenght, value) {
            return ('0000000000' + value).slice(-1 * lenght, value.lenght);
        }
    }]);

    return Bills;
}();

/* harmony default export */ __webpack_exports__["a"] = (Bills);

/***/ }),
/* 4 */,
/* 5 */,
/* 6 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MoneyView = function () {
    function MoneyView() {
        var mainClass = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'paymentTypes';

        _classCallCheck(this, MoneyView);

        this._listOfContents = [];
        this._mainClass = mainClass;
    }

    _createClass(MoneyView, [{
        key: 'get',
        value: function get() {
            var con = this._mountContent();
            return '<span class=\'' + this._mainClass + '\'>' + con + '</span>';
        }
    }, {
        key: 'addContent',
        value: function addContent(innerClass, content) {
            this._listOfContents.push({
                class: innerClass,
                content: content
            });
        }
    }, {
        key: '_mountContent',
        value: function _mountContent() {
            var con = '';
            this._listOfContents.forEach(function (span) {
                con += '<span class="' + span.class + '">' + span.content + '</span>';
            });
            return con;
        }
    }]);

    return MoneyView;
}();

/* harmony default export */ __webpack_exports__["a"] = (MoneyView);

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(0);


/***/ })
/******/ ]);